
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>

        <div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="22">
<h1>REST API</h1>
<p>API (Application Programming Interface) — программный интерфейс приложения. Это набор инструментов, который позволяет одним программам работать с другими. API предусматривает, что программы могут работать на разных компьютерах. В этом случае требуется организовать интерфейс API так, чтобы ПО могло запрашивать функции друг друга через сеть.</p>
<p>API должен учитывать, что программы могут быть написаны на разных языках, поэтому для общения используется независимый от языка формат обмена данными. В этом упражнении мы будем работать с форматом <a href="https://ru.wikipedia.org/wiki/JSON">JSON</a>.</p>
<p>REST API позволяет использовать для общения между программами протокол HTTP. Другими словами, серверное приложение дает доступ к своим данным клиентскому приложению по определенному URL. Чтобы произвести нужные действия с ресурсом, нужно обратиться к нему определённым способом. Для этого используются четыре HTTP метода — GET, POST, PATCH, DELETE. Рассмотрим на примере работы с пользователем:</p>
<ul>
<li data-marpit-fragment="1">GET-запрос на <em>/api/v1/users</em> вернёт список всех пользователей</li>
<li data-marpit-fragment="2">GET-запрос на <em>/api/v1/users/{id}</em> вернёт данные конкретного пользователя</li>
<li data-marpit-fragment="3">POST-запрос на <em>/api/v1/users</em> создаёт нового пользователя</li>
<li data-marpit-fragment="4">PATCH-запрос на <em>/api/v1/users/{id}</em> обновляет данные пользователя</li>
<li data-marpit-fragment="5">DELETE-запрос на <em>/api/v1/users/{id}</em> удаляет пользователя</li>
</ul>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="6"><a href="https://javalin.io/documentation#handler-groups">Метод crud() — используется для разработки API. Он автоматически добавляет в приложение пять маршрутов для CRUD операций</a></li>
<li data-marpit-fragment="7"><a href="https://ebean.io/apidoc/11/io/ebean/text/json/JsonContext.html#toJson-java.lang.Object-">Получение данных из базы в виде JSON представления при помощи метода DB.json().toJson()</a></li>
<li data-marpit-fragment="8"><a href="https://ebean.io/apidoc/11/io/ebean/text/json/JsonContext.html#toBean-java.lang.Class-java.lang.String-">Получение экземпляра модели из JSON представления при помощи метода DB.json().toBean()</a></li>
<li data-marpit-fragment="9"><a href="https://javadoc.io/doc/io.javalin/javalin/latest/io/javalin/http/Context.html">Метод контекста body() — получает тело запроса в виде строки</a></li>
<li data-marpit-fragment="10"><a href="https://javadoc.io/static/io.javalin/javalin/4.1.1/io/javalin/http/Context.html#json(Object)">Метод контекста json() — устанавливает тип содержимого application/json в ответе и отправляет JSON строку в теле ответа</a></li>
<li data-marpit-fragment="11"><a href="https://www.postman.com/">Postman — инструмент для тестирования API</a></li>
</ul>
<h2>src/main/java/exercise/App.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="12">Допишите метод <code>addRoutes()</code>. Добавьте в приложение пять маршрутов для CRUD пользователя, которые были рассмотрены выше. Для этого удобно воспользоваться методом <code>crud()</code>, который автоматически добавит эти маршруты.</li>
</ul>
<h2>src/main/java/exercise/controllers/UserController.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="13">
<p>Допишите метод <code>getAll()</code>, который возвращает список всех пользователей в виде JSON-представления. Для преобразования списка пользователей в JSON можно воспользоваться методом <code>DB.json().toJson()</code></p>
</li>
<li data-marpit-fragment="14">
<p>Допишите метод <code>getOne()</code>, который возвращает конкретного пользователя в виде JSON-представления.</p>
</li>
<li data-marpit-fragment="15">
<p>Допишите метод <code>create()</code>, который создаёт нового пользователя из полученного JSON-представления и добавляет его в базу. Для получения экземпляра модели из JSON-представления можно воспользоваться методом <code>DB.json().toBean()</code>.</p>
</li>
<li data-marpit-fragment="16">
<p>Допишите метод <code>update()</code>, который обновляет данные пользователя в базе данными из полученного JSON-представления.</p>
</li>
<li data-marpit-fragment="17">
<p>Допишите метод, который удаляет пользователя из базы.</p>
</li>
<li data-marpit-fragment="18">
<p>Запустите свое приложение и попробуйте отправлять различные запросы при помощи Postman.</p>
</li>
</ul>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="19">
<p>Метод <code>crud()</code> автоматически добавляет в приложение пять маршрутов для CRUD операций: получение всех сущностей <code>getAll()</code>, получение одной сущности <code>getOne()</code>, создание <code>create()</code>, редактирование <code>update()</code> и удаление <code>delete()</code> сущности.</p>
</li>
<li data-marpit-fragment="20">
<p>Чтобы отправить JSON строку в теле ответа, используйте метод контекста <code>json()</code>.</p>
</li>
<li data-marpit-fragment="21">
<p>В классе <code>User</code> есть метод <code>setId()</code>, который добавляет id пользователя в экземпляр модели. Вы можете воспользоваться им для обновления пользователя в базе. Для этого нужно установить нужный id и вызвать метод <code>update()</code> на модели.</p>
</li>
</ul>
<h2>Самостоятельная работа</h2>
<ul>
<li data-marpit-fragment="22">Добавьте валидацию данных при создании пользователя в метод <code>create()</code>. Условия валидации для данных пользователя установите по своему желанию. Можно взять те же условия, которые были в предыдущем задании. Так как данные пользователя мы получаем в виде JSON-строки, для валидации всего тела запроса целиком можно воспользоваться методом <a href="https://javadoc.io/static/io.javalin/javalin/4.1.1/io/javalin/http/Context.html#bodyValidator(Class)">bodyValidator()</a>. Пример работы этого метода можно посмотреть в <a href="https://javalin.io/documentation#validation">разделе Валидация документации Javalin</a></li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  
